OpenPGP Key Replacement
Daphne Shaw
Jabberwocky Tech
dshaw@jabberwocky.com
Andrew Gallagher, Ed.
PGPKeys.EU
andrewg@andrewg.com
21 October 2024
sec
openpgp
Internet-Draft
This document specifies a method in OpenPGP to suggest a replacement for an expired, revoked, or deprecated primary key.

About This Document
The latest revision of this draft can be found at https://andrewgdotcom.gitlab.io/openpgp-replacementkey. Status information for this document may be found at https://datatracker.ietf.org/doc/draft-ietf-openpgp-replacementkey/.
Discussion of this document takes place on the OpenPGP Working Group mailing list (mailto:openpgp@ietf.org), which is archived at https://mailarchive.ietf.org/arch/browse/openpgp/. Subscribe at https://www.ietf.org/mailman/listinfo/openpgp/.
Source for this draft and an issue tracker can be found at https://gitlab.com/andrewgdotcom/openpgp-replacementkey.
Introduction
The OpenPGP message format [RFC9580] defines two ways to invalidate a primary key. One way is that the primary key may be explicitly revoked via a key revocation signature. OpenPGP also supports the concept of key expiration, a date after which the key should not be used. When a primary key is revoked or expires, very often there is another primary key that is intended to replace it.
A key owner may also create a new primary key that is intended to deprecate and replace their existing primary key, but without revoking or expiring that key. This is useful during the rollout of new key versions and algorithms which may not (yet) enjoy universal support. In such cases, a key owner may prefer that their correspondents use their new primary key, but if this is not possible for technical reasons they may continue to use the non-preferred key, which remains valid.
In the past some key owners have created key transition documents, which are signed, human-readable statements stating that a newer primary key should be preferred by their correspondents. It is desirable that this process be automated through a standardised machine-readable mechanism.
This document is to specify the format of a Signature Subpacket to be optionally included in a revocation signature or direct self-signature over a primary key. This subpacket contains a pointer to a suggested replacement for the primary key that is signed over, or a primary key for which the current primary key is the suggested replacement. The corresponding replacement certificate may then be automatically retrieved and (if supported and validated) used instead of the original.
Conventions and Definitions
The key words "MUST", "MUST NOT", "REQUIRED", "SHALL", "SHALL NOT", "SHOULD", "SHOULD NOT", "RECOMMENDED", "NOT RECOMMENDED", "MAY", and "OPTIONAL" in this document are to be interpreted as described in BCP 14 [RFC2119] [RFC8174] when, and only when, they appear in all capitals, as shown here.
Terminology
In OpenPGP, the term "key" has historically been used loosely to refer to several distinct concepts. Care is therefore required when talking about "keys" in a non-specific sense. In this document, we use the following convention:
- "replacement primary key" and "original primary key" refer to a primary key as contained in a Transferable Public Key (certificate) or Transferable Secret Key.
- "target key" refers to either a replacement or original primary key that is referred to by a record in a Replacement Key subpacket.
- "current primary key" refers to the primary key that the self-signature currently under discussion belongs to.
- "replacement certificate", "original certificate" and "current certificate" refer to the TPK within which the corresponding primary key is distributed.
The Replacement Key Subpacket
The Replacement Key subpacket is a Signature Subpacket ([RFC9580] section 5.2.3.7), and all general Signature Subpacket considerations from there apply here as well. The value of the Signature Subpacket type octet for the Replacement Key subpacket is (insert this later).
A Preferred Key Server subpacket ([RFC9580] section 5.2.3.26) MAY be included in the revocation or direct key signature to recommend a location and method to fetch the replacement certificate. Note however that since this subpacket automatically also applies to the current certificate, it cannot be used to set the replacement certificate's preferred keyserver to a different value than that of the current certificate.
To explicitly state that the current primary key has no replacement (or original), a Replacement Key subpacket with the "no replacement" bit set, and with no target key specified, is used (see below). The absence of a Replacement Key subpacket SHOULD NOT be interpreted as meaning that there is no replacement (or original) for the current primary key.
The Replacement Key subpacket MUST only be used in the hashed subpackets area of a primary key revocation or direct key signature.
Format of the Replacement Key Subpacket
The format of the Replacement Key subpacket is:

Replacement Key Subpacket Fields
Octets | Field | Notes
1 | Class |
1 | Record length (1) | optional
1 | Target Key Version (1) | optional
N1 | Target Key Fingerprint (1) | optional
M | Target Key Imprint (1) | optional
1 | Record length (2) | optional
1 | Target Key Version (2) | optional
N2 | Target Key Fingerprint (2) | optional
M | Target Key Imprint (2) | optional
... | ... | ...
The class octet contains flags that indicate the form and semantics of the subpacket:

Replacement Key Subpacket Flags
Flag bit | Flag name | Form of remainder of packet
0x80 | No replacement | No optional fields
0x40 | Inverse relationship | Multiple targets may be given
The 0x80 bit of the class octet is the "no replacement" bit. When set, this explicitly specifies there is neither a replacement nor an original primary key for the current primary key.
The 0x40 bit of the class octet is the "inverse relationship" bit. When set, this means that the target key(s) identified by the packet are the primary keys for which the current primary key is the replacement primary key.
All other bits of the class octet are currently undefined and MUST be set to zero. An implementation that encounters a class octet that has other bits set MUST disregard that Replacement Key subpacket.
Note that if the critical bit on the Replacement Key subpacket is set, a receiving implementation could consider the whole self-signature to be in error ([RFC9580] section 5.2.3.7). The critical bit therefore SHOULD NOT be set on the Replacement Key subpacket.
The remainder of the subpacket contains zero or more target records of the form ( Record Length || Target Key Version || Target Key Fingerprint || Target Key Imprint ). The Record Length field indicates the length of the next three fields; a pointer incremented by this length will skip to the beginning of the next record.
- If the class octet has the 0x80 bit set, the subpacket MUST contain zero target records.
- Otherwise, if the class octet does not have the 0x40 bit set, the subpacket MUST contain exactly one target record to identify the replacement primary key.
- Otherwise, if the class octet has the 0x40 bit set, the subpacket MUST contain one or more target records, to identify the original primary keys that the current primary key is a replacement for.
If present, the length of the Target Key Fingerprint field (N) MUST equal the fingerprint length corresponding to the immediately preceding Target Key Version field, e.g. 20 octets for version 4, or 32 octets for version 6. If present, the length of the Target Key Imprint field (M) MUST equal the length of the output of the digest algorithm used by the enclosing signature, e.g. 32 octets for SHA2-256.
If the intent is to state that the replacement (or original) primary key is unknown, then no Replacement Key subpacket should be included in the signature.
Key Imprints
An imprint of a public key packet is a generalisation of a fingerprint. It is calculated in the same way as the fingerprint, except that it MAY use a digest algorithm other than the one specified for the fingerprint. Conversely, the fingerprint of a public key packet can be considered a special case of an imprint. A public key packet has only one fingerprint, but may have any number of imprints, each using a different digest algorithm.
When used in a Replacement Key subpacket, an imprint MUST use the same digest algorithm as the enclosing signature. This guards against key-substitution attacks when referring to keys that use weaker digest algorithms in their fingerprints. If the signature's digest algorithm is the same as that used by the fingerprint, then the imprint and the fingerprint will be identical. In such a case, the imprint MUST still be included for parsing reasons.
Graph Topology
A given signature MUST contain at most one Replacement Key subpacket. If a signature contains more than one such subpacket, a receiving implementation MUST disregard them all. This imposes a simple graph topology:
- An original certificate MUST NOT claim to have more than one replacement.
- An original certificate that claims to have a replacement MUST NOT claim to be the replacement for any other(s).
In addition, the order of the original primary keys specified in an inverse-relationship Replacement Key subpacket is meaningful. If a replacement primary key is supported by a receiving implementation, but is not usable for the desired purpose (for example, it may not have an encryption-capable subkey), the implementation MAY use the ordering of the original primary keys in its inverse Replacement Key subpacket (if one exists) to indicate which original primary key is preferred as a fallback. The original primary keys SHOULD therefore be listed in order of decreasing preference.
Trust and Validation of the Replacement Key Subpacket
Key Equivalence Binding
The existence of a matching pair of forward and inverse Replacement Key subpackets on the most recent direct self-signatures (or key revocations) over two primary keys, with each referring to the other primary key, forms a Key Equivalence Binding. If one primary key is validated for use in a particular context, then a bound-equivalent primary key and its subkeys are also valid, regardless of any User ID certifications over the second primary key (or lack thereof).
The equivalence binding is invalidated under the following circumstances:
- if either primary key is hard-revoked.
- if either primary key overrides the equivalence binding with a new direct self-signature that a) does not contain a Replacement Key subpacket, or b) contains a Replacement Key subpacket that does not refer to the other key.
- if either signature that forms the equivalence binding has expired.
Note however:
- If either primary key is soft-revoked or expired, the equivalence binding is unaffected.
- If either primary key is hard-revoked, then the equivalence binding is invalidated and the other key is unaffected.
- Other properties (such as expiry dates, usage preferences, custom notations) SHOULD NOT be applied across the equivalence binding.
- Key Equivalence is transitive; if A is equivalent to B and B is equivalent to C, then A is equivalent to C.
If two or more primary keys are bound-equivalent, they MUST be treated as a single key for the purposes of the Web of Trust, particularly when calculating partial trust values.
Without a Key Equivalence Binding
The Replacement Key subpacket MUST NOT be treated as a Web of Trust certification over either the current or replacement primary key. In the absence of a Key Equivalence Binding, a receiving implementation SHOULD validate the replacement certificate as they would any other. If the replacement certificate is supported, and validates successfully, it SHOULD be preferred over the current certificate when determining which one to use for correspondence.
It is also suggested that the key owner asks the third parties who certified their original primary key to certify the replacement primary key. Distribution of the replacement certificate over a trusted mechanism (such as WKD) MAY also be used to confer legitimacy.
Selection of Encryption Subkeys
If a replacement certificate has been validated, whether through key equivalence or other means, correspondents SHOULD assign it preference over the current certificate. When a correspondent of the key owner selects subkeys for encryption, the subkeys of the replacement primary key SHOULD therefore be considered first. If there are no usable subkeys on the replacement primary key, then:
- If there is an equivalence binding, the subkeys of the first listed original primary key SHOULD be considered next. If none of those are usable, then the subkeys of the next original primary key (if any) SHOULD be considered, and so forth.
- If there is no equivalence binding, the subkeys of the current primary key SHOULD be used.
Placement of the Replacement Key Subpacket
The Replacement Key subpacket is only meaningful on a primary key revocation or direct key signature, and MUST NOT appear elsewhere. The Replacement Key subpacket MUST be placed in the hashed subpackets area of the signature to prevent a possible key substitution attack. If the Replacement Key subpacket was allowed in the unhashed subpackets area, an attacker could add a bogus Replacement Key subpacket to an existing signature.
Security Considerations
A Key Equivalence Binding requires the active consent of both primary key owners. This is to prevent one key owner from unilaterally claiming signatures made by the other key owner, using the same argument that motivates the embedded Primary Key Binding signature in a signing-capable subkey's binding signature.
The Target Key Imprint is included to mitigate against weaknesses in the fingerprint digest algorithm used by older key versions. By including a digest over the target primary public key packet, using the same digest algorithm as the enclosing signature, we ensure that the indirect cryptographic binding between the equivalent keys is of the same overall strength as a signature made directly over the target primary public key (as in a certification signature or subkey binding signature). We intentionally chose not to use embedded back-signatures or third-party certifications, both to keep the design simple and to limit the size of the subpacket(s) required.
In the absence of a complete Key Equivalence Binding, the Replacement Key subpacket MUST be treated as merely advisory. In this scenario, it provides information for the purposes of key discovery and order of preference only, without any trust statement regarding the replacement. Implementations SHOULD NOT infer any trust value from a single Replacement Key subpacket, and SHOULD validate the replacement certificate as they would any other.
In addition, as this document is an update of [RFC9580], the security considerations there should be carefully reviewed.
IANA Considerations
This document requests that the following entry be added to the OpenPGP Signature Subpacket registry:

Signature Subpacket Registry
Type | Name | Specification
TBC | Replacement Key | This document

Normative References
[RFC9580]

OpenPGP
P. Wouters, Ed.
D. Huigens
J. Winter
Y. Niibe
July 2024
RFC 9580
DOI 10.17487/RFC9580
[RFC2119]

Key words for use in RFCs to Indicate Requirement Levels
S. Bradner
March 1997
BCP 14
RFC 2119
DOI 10.17487/RFC2119
[RFC8174]

Ambiguity of Uppercase vs Lowercase in RFC 2119 Key Words
B. Leiba
May 2017
BCP 14
RFC 8174
DOI 10.17487/RFC8174
Example Workflows
Alice Revokes her Primary Key
- Bob wants to send Alice a message; Bob has Alice's original certificate but they have not corresponded for some time.
- Bob's client refreshes Alice’s original certificate from a keyserver (by primary key fingerprint); it contains a revocation signature with a Replacement Key subpacket.
- Bob's client looks up Alice’s replacement certificate on a keyserver (by primary key fingerprint); it is certified by the same people that certified her original (some of whom Bob may trust) and/or Alice’s original itself (which Bob's policy may consider sufficient).
- Bob's client uses Alice’s replacement certificate instead of the original certificate.
There are other means to achieve a similar result, such as WKD or Autocrypt, but they may not be available. For example, Alice’s service provider may not support WKD, and Alice may not have sent Bob an autocrypt message since revoking her original primary key.
Alice Creates a V6 Primary Key
- Bob wants to send Alice a message and has Alice's v4 original certificate.
- Either Bob's copy of Alice's original certificate already has the Replacement Key subpacket pointing to a v6 primary key, or Bob refreshes Alice's original certificate from a keyserver and sees a new Replacement Key subpacket.
- If Bob has a v6 implementation, it can proceed with fetching Alice's v6 replacement certificate, validating it, etc, and then use it to send his message to Alice.
- If Bob doesn't have a v6 implementation, it can continue to use Alice's v4 original certificate.
WKD does not currently allow more than one valid certificate to be returned for a query, therefore it cannot easily support this use case.
Acknowledgments
The authors would like to thank Bart Butler, Kai Engert, Daniel Kahn Gillmor, Daniel Huigens, Simon Josefsson, Heiko Schäfer, Falko Strenzke, Justus Winter and Aron Wussler for suggestions and discussions.
Document History
Note to RFC Editor: this section should be removed before publication.
Changes Between -00 and -01
- Updated references to RFC9580.
- Removed subpacket version octet.
- Added guidance for encryption subkey selection.
- Added record length fields.
- Renamed to "OpenPGP Key Replacement" and normalised terminology.
Changes Between draft-gallagher-openpgp-replacementkey-02 and draft-ietf-openpgp-replacementkey-00
- Standardised capitalisation and terminology.
Changes Between -01 and -02
- Specified Public Key Imprints.
- Specified inverse relationship flag and packet format.
- Restricted graph topology.
- Specified Key Equivalence Binding.
- Guidance re subpacket placement escalated from SHOULD to MUST, and critical bit to SHOULD NOT.
Changes Between -00 and -01
- Added example workflows.
- Specifically describe "deprecation without expiry or revocation" use case.
- Add note about weakness of signatures over fingerprints.
- Miscellaneous clarifications.
Changes Between draft-shaw-openpgp-replacementkey-00 and draft-gallagher-openpgp-replacementkey-00
- Changed algid octet to key version octet.
- Changed initial subpacket version number to 1.
- Clarified semantics of some edge cases.